=== arangod/CMakeLists.txt ===
#- * - mode : CMAKE; - * -

include_directories(.)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin/")

################################################################################
## BISON/FLEX
################################################################################

#note that we check - in the generated FLEX / BISON files, therefore they are
#generate inside the source tree

if (USE_MAINTAINER_MODE AND NOT MSVC)
  set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM "On")

  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/Aql/tokens.cpp
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMAND ${FLEX_EXECUTABLE} -L -oAql/tokens.cpp Aql/tokens.ll
    MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/Aql/tokens.ll
    VERBATIM
  )

  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/Aql/grammar.cpp
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMAND ${CMAKE_SOURCE_DIR}/utils/bison-c.sh
      ${BISON_EXECUTABLE} Aql/grammar.cpp Aql/grammar.y
    MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/Aql/grammar.y
    VERBATIM
  )

  add_custom_target(clean_aql_autogenerated
    COMMAND rm -f Aql/tokens.cpp Aql/tokens.h Aql/grammar.cpp Aql/grammar.h
  )

  list(APPEND CLEAN_AUTOGENERATED_FILES clean_aql_autogenerated)
  set(CLEAN_AUTOGENERATED_FILES ${CLEAN_AUTOGENERATED_FILES} PARENT_SCOPE)
endif ()

if (CMAKE_COMPILER_IS_GNUCC)
  set_source_files_properties(Aql/tokens.cpp PROPERTIES COMPILE_FLAGS -Wno-sign-compare)
endif ()

################################################################################
## IResearch
################################################################################

find_package(IResearch REQUIRED)

add_library(arango_iresearch
  STATIC
  IResearch/ApplicationServerHelper.h IResearch/ApplicationServerHelper.cpp
  IResearch/AqlHelper.cpp IResearch/AqlHelper.h
  IResearch/Containers.cpp IResearch/Containers.h
  IResearch/ExpressionFilter.cpp IResearch/ExpressionFilter.h
  IResearch/Geo.cpp IResearch/Geo.h
  IResearch/GeoAnalyzer.cpp IResearch/GeoAnalyzer.h
  IResearch/GeoFilter.cpp IResearch/GeoFilter.h
  IResearch/IResearchAnalyzerFeature.cpp IResearch/IResearchAnalyzerFeature.h
  IResearch/IResearchAqlAnalyzer.cpp IResearch/IResearchAqlAnalyzer.h
  IResearch/IResearchCommon.cpp IResearch/IResearchCommon.h
  IResearch/IResearchCompression.cpp IResearch/IResearchCompression.h
  IResearch/IResearchDocument.cpp IResearch/IResearchDocument.h
  IResearch/IResearchExpressionContext.cpp IResearch/IResearchExpressionContext.h
  IResearch/IResearchFeature.cpp IResearch/IResearchFeature.h
  IResearch/IResearchFilterFactory.cpp IResearch/IResearchFilterFactory.h
  IResearch/IResearchIdentityAnalyzer.cpp IResearch/IResearchIdentityAnalyzer.h
  IResearch/IResearchKludge.cpp IResearch/IResearchKludge.h
  IResearch/IResearchLink.cpp IResearch/IResearchLink.h
  IResearch/IResearchLinkCoordinator.cpp IResearch/IResearchLinkCoordinator.h
  IResearch/IResearchLinkHelper.cpp IResearch/IResearchLinkHelper.h
  IResearch/IResearchLinkMeta.cpp IResearch/IResearchLinkMeta.h
  IResearch/IResearchOrderFactory.cpp IResearch/IResearchOrderFactory.h
  IResearch/IResearchPDP.cpp IResearch/IResearchPDP.h
  IResearch/IResearchPrimaryKeyFilter.cpp IResearch/IResearchPrimaryKeyFilter.h
  IResearch/IResearchRocksDBLink.cpp IResearch/IResearchRocksDBLink.h
  IResearch/IResearchRocksDBRecoveryHelper.cpp
  IResearch/IResearchRocksDBRecoveryHelper.h
  IResearch/IResearchVPackComparer.cpp IResearch/IResearchVPackComparer.h
  IResearch/IResearchView.cpp IResearch/IResearchView.h
  IResearch/IResearchViewCoordinator.cpp IResearch/IResearchViewCoordinator.h
  IResearch/IResearchViewMeta.cpp IResearch/IResearchViewMeta.h
  IResearch/IResearchViewSort.cpp IResearch/IResearchViewSort.h
  IResearch/IResearchViewStoredValues.cpp IResearch/IResearchViewStoredValues.h
  IResearch/VelocyPackHelper.cpp IResearch/VelocyPackHelper.h
  RestHandler/RestAnalyzerHandler.cpp RestHandler/RestAnalyzerHandler.h
)

target_compile_definitions(arango_iresearch
  PUBLIC "$<$<CONFIG:Debug>:IRESEARCH_DEBUG=1>"
)

set(IRESEARCH_TARGET_DEPENDENCY iresearch-static) # use static to match ArangoDB


get_target_property(IRESEARCH_INCLUDE
  ${IRESEARCH_TARGET_DEPENDENCY} INCLUDE_DIRECTORIES)

target_include_directories(arango_iresearch
  PUBLIC ${IRESEARCH_INCLUDE}
)

if (USE_ENTERPRISE)
  target_include_directories(arango_iresearch
    PUBLIC "${PROJECT_SOURCE_DIR}/${ENTERPRISE_INCLUDE_DIR}"
  )
endif()

target_link_libraries(arango_iresearch
  ${IRESEARCH_TARGET_DEPENDENCY}
  s2 # needed for some includes
  boost_locale # required by iResearch
)

add_dependencies(arango_iresearch
  ${IRESEARCH_TARGET_DEPENDENCY}
  v8_build # for ICU required by iResearch
)

################################################################################
# llhttp
################################################################################


SET(LLHTTP_SOURCES
  ${PROJECT_SOURCE_DIR}/3rdParty/llhttp/src/api.c
  ${PROJECT_SOURCE_DIR}/3rdParty/llhttp/src/http.c
  ${PROJECT_SOURCE_DIR}/3rdParty/llhttp/src/llhttp.c
)


################################################################################
## arangod
################################################################################

if (MSVC AND NOT(SKIP_PACKAGING))
  generate_product_version(ProductVersionFiles
    NAME arangod
    FILE_DESCRIPTION ${ARANGODB_FRIENDLY_STRING}
    ICON ${ARANGO_ICON}
    VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR}
    VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR}
    VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH}
    VERSION_REVISION ${BUILD_ID}
  )
endif ()

if (USE_ENTERPRISE)
  set(ENTERPRISE_FILES "")
else ()
  set(ENTERPRISE_FILES
    Utils/Events.cpp
  )
endif ()

set(LIB_ARANGO_GRAPH_SOURCES
  Aql/PruneExpressionEvaluator.cpp
  Cluster/CallbackGuard.cpp
  Cluster/ClusterEdgeCursor.cpp
  Cluster/ClusterTraverser.cpp
  Cluster/ServerDefaults.cpp
  Cluster/TraverserEngine.cpp
  Graph/AttributeWeightShortestPathFinder.cpp
  Graph/BaseOptions.cpp
  Graph/BreadthFirstEnumerator.cpp
  Graph/ClusterGraphDatalake.cpp
  Graph/ClusterTraverserCache.cpp
  Graph/ConstantWeightShortestPathFinder.cpp
  Graph/Graph.cpp
  Graph/GraphManager.cpp
  Graph/GraphOperations.cpp
  Graph/KShortestPathsFinder.cpp
  Graph/NeighborsEnumerator.cpp
  Graph/PathEnumerator.cpp
  Graph/ShortestPathFinder.cpp
  Graph/ShortestPathOptions.cpp
  Graph/ShortestPathResult.cpp
  Graph/ShortestPathType.cpp
  Graph/SingleServerEdgeCursor.cpp
  Graph/SingleServerTraverser.cpp
  Graph/Traverser.cpp
  Graph/TraverserCache.cpp
  Graph/TraverserCacheFactory.cpp
  Graph/TraverserDocumentCache.cpp
  Graph/TraverserOptions.cpp
  Graph/WeightedEnumerator.cpp
  Graph/Cursors/RefactoredSingleServerEdgeCursor.cpp
  Graph/Cache/RefactoredTraverserCache.cpp
  Graph/Cache/RefactoredClusterTraverserCache.cpp
  Graph/Enumerators/TwoSidedEnumerator.cpp
  Graph/Helpers/TraceEntry.cpp
  Graph/Queues/QueueTracer.cpp
  Graph/PathManagement/PathResult.cpp
  Graph/PathManagement/PathStore.cpp
  Graph/PathManagement/PathStoreTracer.cpp
  Graph/PathManagement/PathValidator.cpp
  Graph/Options/TwoSidedEnumeratorOptions.cpp
  Graph/Providers/ClusterProvider.cpp
  Graph/Providers/SingleServerProvider.cpp
  Graph/Providers/BaseProviderOptions.cpp
  Graph/Providers/ProviderTracer.cpp
  Graph/Types/UniquenessLevel.cpp
  Graph/Types/ValidationResult.cpp
  InternalRestHandler/InternalRestTraverserHandler.cpp
  RestHandler/RestGraphHandler.cpp
)

set(LIB_ARANGO_PREGEL_AIR_SOURCES
  Pregel/Algos/AIR/AIR.cpp
  Pregel/Algos/AIR/AbstractAccumulator.cpp
  Pregel/Algos/AIR/AccumulatorOptions.cpp
  Pregel/Algos/AIR/Accumulators.cpp
  Pregel/Algos/AIR/EdgeData.cpp
  Pregel/Algos/AIR/GraphFormat.cpp
  Pregel/Algos/AIR/MasterContext.cpp
  Pregel/Algos/AIR/MessageData.cpp
  Pregel/Algos/AIR/MessageFormat.cpp
  Pregel/Algos/AIR/VertexComputation.cpp
  Pregel/Algos/AIR/VertexData.cpp
  Pregel/Algos/AIR/WorkerContext.cpp
)

set(LIB_ARANGO_PREGEL_SOURCES
  Pregel/AggregatorHandler.cpp
  Pregel/AlgoRegistry.cpp
  Pregel/Algos/AsyncSCC.cpp
  Pregel/Algos/ConnectedComponents.cpp
  Pregel/Algos/DMID/DMID.cpp
  Pregel/Algos/EffectiveCloseness/EffectiveCloseness.cpp
  Pregel/Algos/EffectiveCloseness/HLLCounter.cpp
  Pregel/Algos/HITS.cpp
  Pregel/Algos/LabelPropagation.cpp
  Pregel/Algos/LineRank.cpp
  Pregel/Algos/PageRank.cpp
  Pregel/Algos/RecoveringPageRank.cpp
  Pregel/Algos/SCC.cpp
  Pregel/Algos/SLPA.cpp
  Pregel/Algos/SSSP.cpp
  Pregel/Algos/ShortestPath.cpp
  Pregel/Algos/WCC.cpp
  Pregel/Conductor.cpp
  Pregel/GraphStore.cpp
  Pregel/IncomingCache.cpp
  Pregel/IndexHelpers.cpp
  Pregel/OutgoingCache.cpp
  Pregel/PregelFeature.cpp
  Pregel/Recovery.cpp
  Pregel/Reports.cpp
  Pregel/Reports.h
  Pregel/Utils.cpp
  Pregel/Worker-templates-algorithms.cpp
  Pregel/Worker-templates-native-types.cpp
  Pregel/Worker.cpp
  Pregel/WorkerConfig.cpp
  RestHandler/RestControlPregelHandler.cpp
  RestHandler/RestPregelHandler.cpp
)

set(LIB_ARANGO_AQL_SOURCES
  Aql/Aggregator.cpp
  Aql/AllRowsFetcher.cpp
  Aql/AqlCall.cpp
  Aql/AqlCallList.cpp
  Aql/AqlCallSet.cpp
  Aql/AqlCallStack.cpp
  Aql/AqlExecuteResult.cpp
  Aql/AqlFunctionFeature.cpp
  Aql/AqlFunctionsInternalCache.cpp
  Aql/AqlItemBlock.cpp
  Aql/AqlItemBlockInputMatrix.cpp
  Aql/AqlItemBlockInputRange.cpp
  Aql/AqlItemBlockManager.cpp
  Aql/AqlItemBlockUtils.cpp
  Aql/AqlItemMatrix.cpp
  Aql/AqlTransaction.cpp
  Aql/AqlValue.cpp
  Aql/AqlValueGroup.cpp
  Aql/AqlValueMaterializer.cpp
  Aql/Arithmetic.cpp
  Aql/Ast.cpp
  Aql/AstHelper.cpp
  Aql/AstNode.cpp
  Aql/AstResources.cpp
  Aql/AsyncExecutor.cpp
  Aql/AttributeAccessor.cpp
  Aql/AttributeNamePath.cpp
  Aql/BindParameters.cpp
  Aql/BlocksWithClients.cpp
  Aql/CalculationExecutor.cpp
  Aql/CalculationNodeVarFinder.cpp
  Aql/ClusterNodes.cpp
  Aql/CollectNode.cpp
  Aql/CollectOptions.cpp
  Aql/Collection.cpp
  Aql/CollectionAccess.cpp
  Aql/CollectionAccessingNode.cpp
  Aql/Collections.cpp
  Aql/Condition.cpp
  Aql/ConditionFinder.cpp
  Aql/ConstFetcher.cpp
  Aql/ConstrainedSortExecutor.cpp
  Aql/CostEstimate.cpp
  Aql/CountCollectExecutor.cpp
  Aql/DependencyProxy.cpp
  Aql/DistinctCollectExecutor.cpp
  Aql/DistributeClientBlock.cpp
  Aql/DistributeConsumerNode.cpp
  Aql/DistributeExecutor.cpp
  Aql/DocumentExpressionContext.cpp
  Aql/DocumentIndexExpressionContext.cpp
  Aql/DocumentProducingHelper.cpp
  Aql/DocumentProducingNode.cpp
  Aql/ClusterQuery.cpp
  Aql/EngineInfoContainerCoordinator.cpp
  Aql/EngineInfoContainerDBServerServerBased.cpp
  Aql/EnumerateCollectionExecutor.cpp
  Aql/EnumerateListExecutor.cpp
  Aql/ExecutionBlock.cpp
  Aql/ExecutionBlockImpl.cpp
  Aql/ExecutionEngine.cpp
  Aql/ExecutionNode.cpp
  Aql/ExecutionNodeId.cpp
  Aql/ExecutionPlan.cpp
  Aql/ExecutionState.cpp
  Aql/ExecutionStats.cpp
  Aql/ExecutorExpressionContext.cpp
  Aql/Expression.cpp
  Aql/FilterExecutor.cpp
  Aql/FixedVarExpressionContext.cpp
  Aql/Function.cpp
  Aql/Functions.cpp
  Aql/GraphNode.cpp
  Aql/Graphs.cpp
  Aql/HashedCollectExecutor.cpp
  Aql/IResearchViewExecutor.cpp
  Aql/IResearchViewNode.cpp
  Aql/IResearchViewOptimizerRules.cpp
  Aql/IdExecutor.cpp
  Aql/InAndOutRowExpressionContext.cpp
  Aql/IndexExecutor.cpp
  Aql/IndexHint.cpp
  Aql/IndexNode.cpp
  Aql/IndexNodeOptimizerRules.cpp
  Aql/InputAqlItemRow.cpp
  Aql/InsertModifier.cpp
  Aql/KShortestPathsExecutor.cpp
  Aql/KShortestPathsNode.cpp
  Aql/LateMaterializedOptimizerRulesCommon.cpp
  Aql/LimitExecutor.cpp
  Aql/LimitStats.cpp
  Aql/MaterializeExecutor.cpp
  Aql/ModificationExecutor.cpp
  Aql/ModificationExecutorHelpers.cpp
  Aql/ModificationExecutorInfos.cpp
  Aql/ModificationNodes.cpp
  Aql/ModificationOptions.cpp
  Aql/MultiAqlItemBlockInputRange.cpp
  Aql/MultiDependencySingleRowFetcher.cpp
  Aql/MutexExecutor.cpp
  Aql/MutexNode.cpp
  Aql/NodeFinder.cpp
  Aql/NonConstExpression.cpp
  Aql/NonConstExpressionContainer.cpp
  Aql/NoResultsExecutor.cpp
  Aql/Optimizer.cpp
  Aql/OptimizerRules.cpp
