=== Installation/debian/control ===
Source: arangodb3
Section: database
Priority: optional
Maintainer: ArangoDB GmbH <info@arangodb.com>
Build-Depends: debhelper (>= 5), libreadline-dev, libssl-dev, python, libicu-dev, libtool, autoconf, automake

Package: arangodb3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: arangodb3-client
Description: a multi-purpose NoSQL database
 A distributed free and open-source database with a flexible data model for documents,
 graphs, and key-values. Build high performance applications using a convenient
 SQL-like query language or JavaScript extensions.
 .
 Copyright: 2012-2013 by triAGENS GmbH
 Copyright: 2014-2015 by ArangoDB GmbH
 ArangoDB Software
 www.arangodb.com

Package: arangodb3-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: arangodb
Description: stand-alone shell
 A distributed free and open-source database with a flexible data model for documents,
 graphs, and key-values. Build high performance applications using a convenient
 SQL-like query language or JavaScript extensions.
 .
 Copyright: 2012-2013 by triAGENS GmbH
 Copyright: 2014-2015 by ArangoDB GmbH
 ArangoDB Software
 www.arangodb.com

Package: arangodb-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
    arangodb (= ${binary:Version}),
    ${misc:Depends}
Description: debugging symbols for arangodb
 A distributed free and open-source database with a flexible data model for documents,
 graphs, and key-values. Build high performance applications using a convenient
 SQL-like query language or JavaScript extensions.
 .
 This package contains the debugging symbols for giblib1.
